<template>
  <GI18nCard :card="card" :i18n="i18n" :wiki-entry="wikiEntry">
    <template #card-title-append>
      <v-spacer />
      <GDropDownMenu
        i18n="form.addElement"
        :available-elements="availableElements"
        icon="add"
        :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
        @addElement="addElement"
      />
    </template>
    <v-row dense>
      <GCol cols="12">
        <GAutocomplete
          v-model="value.countryCodeISO3166_1._text"
          :items="countryCodes"
          :item-text="(item) => `${item.code} - ${item.name}`"
          item-value="code"
          i18n="dcc.administrativeData.coreData.countryCodeISO3166_1"
          validate="required"
          :wiki-entry="wikiEntry + 'CountryCode'"
        />
      </GCol>
      <GCol cols="12">
        <Language
          v-model="value"
          :dialog="languageDialog"
          :mode="languageAddingMode"
          @closeDialog="languageDialog = false"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.uniqueIdentifier"
          i18n="dcc.administrativeData.coreData.uniqueIdentifier"
          validate="required notEmptyStringType"
          :wiki-entry="wikiEntry + 'UniqueIdentifier'"
        />
      </GCol>
      <GCol cols="12" md="6">
        <DccDatePicker
          v-model="value.receiptDate"
          i18n="dcc.administrativeData.coreData.receiptDate"
          :wiki-entry="wikiEntry + 'ReceiptDate'"
        />
      </GCol>
      <GCol v-if="!isPerformanceRange" cols="12" md="4">
        <DccDatePicker
          v-model="performanceDate"
          i18n="dcc.administrativeData.coreData.performanceDate"
          validate="required"
          :wiki-entry="wikiEntry + 'BeginPerformanceDate'"
        />
      </GCol>
      <GCol v-if="isPerformanceRange" cols="4">
        <DccDatePicker
          v-model="value.beginPerformanceDate"
          i18n="dcc.administrativeData.coreData.beginPerformanceDate"
          :max="value.endPerformanceDate._text"
          validate="required"
          :wiki-entry="wikiEntry + 'BeginPerformanceDate'"
        />
      </GCol>
      <GCol cols="4">
        <GCheckbox
          v-model="isPerformanceRange"
          i18n="dcc.administrativeData.coreData.isPerformanceRange"
        />
      </GCol>
      <GCol v-if="isPerformanceRange" cols="4">
        <DccDatePicker
          v-model="value.endPerformanceDate"
          i18n="dcc.administrativeData.coreData.endPerformanceDate"
          :min="value.beginPerformanceDate._text"
          validate="required"
          :wiki-entry="wikiEntry + 'EndPerformanceDate'"
        />
      </GCol>
      <GCol cols="12" md="6">
        <DccSelect
          v-model="value.performanceLocation"
          i18n="dcc.administrativeData.coreData.performanceLocation"
          :items="stringPerformanceLocation"
          validate="required"
          :wiki-entry="wikiEntry + 'PerformanceLocation'"
        />
      </GCol>
      <!--
      <GCol cols="12" md="6">
        <GTextField
          v-model="value.performanceLocation._attr.id"
          i18n="dcc.administrativeData.coreData.performanceLocationId"
          attr-ref-type
        />
      </GCol>
      -->
      <GCol cols="12" md="6">
        <DccDatePicker
          v-model="value.issueDate"
          i18n="dcc.administrativeData.coreData.issueDate"
          :wiki-entry="wikiEntry + 'issueDate'"
        />
      </GCol>
      <GCol v-if="value.identifications" cols="12">
        <IdentificationList
          ref="identifications"
          v-model="value.identifications"
          optional
          level="second"
          :wiki-entry="wikiEntry + 'Identifications'"
          @delete="deleteIdentifications"
        />
      </GCol>
      <GCol v-if="value.reportAmendedSubstituted" cols="12">
        <ReportAmendedSubstituted
          ref="reportAmendedSubstituted"
          v-model="value.reportAmendedSubstituted"
          level="second"
          @delete="deleteReportAmendedSubstituted"
        />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import {
  IdentificationListType,
  ReportAmendedSubstitutedType,
} from "@d-ptb/dcc-js";
import GI18nCard from "../../App/Common/GI18nCard";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import DccDatePicker from "../../App/Form/XML/DccDatePicker";
import GCheckbox from "../../App/Form/gCheckbox";
import GAutocomplete from "../../App/Form/gAutocomplete";
import ISO3611 from "~/assets/lists/iso-3611-codes";
import ISO639 from "~/assets/lists/iso-639-codes";
import IdentificationList from "~/components/DCC/Common/IdentificationList";
import DccSelect from "~/components/App/Form/XML/DccSelect";
import GCol from "~/components/App/Common/GCol";
import Language from "~/components/DCC/AdministrativeData/Language.vue";
import ReportAmendedSubstituted from "~/components/DCC/AdministrativeData/ReportAmendedSubstituted.vue";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";
import { insertIf } from "~/assets/util/general";

const stringPerformanceLocation = [
  "laboratory",
  "customer",
  "laboratoryBranch",
  "customerBranch",
  "other",
];

export default {
  name: "CoreData",
  components: {
    GDropDownMenu,
    ReportAmendedSubstituted,
    Language,
    GCol,
    DccSelect,
    IdentificationList,
    GAutocomplete,
    GCheckbox,
    DccDatePicker,
    XmlTextField,
    GI18nCard,
  },
  props: {
    value: Object,
    i18n: {
      type: String,
      default: "dcc.administrativeData.coreData.title",
    },
    card: {
      type: Boolean,
      default: true,
    },
    wikiEntry: String,
    level: String,
  },
  data() {
    return {
      countryCodes: ISO3611,
      langCodes: ISO639,
      isPerformanceRange: false,
      languageDialog: false,
      languageAddingMode: "",
    };
  },
  computed: {
    performanceDate: {
      get() {
        return this.value.beginPerformanceDate;
      },
      set(value) {
        const text = value ? value._text : "";
        this.value.beginPerformanceDate._text = text;
        this.value.endPerformanceDate._text = text;
      },
    },
    stringPerformanceLocation() {
      return stringPerformanceLocation.map((x) => {
        return {
          key: x,
          text: this.$t(
            `dcc.administrativeData.coreData.stringPerformanceLocation.${x}`
          ),
        };
      });
    },
    availableElements() {
      return [
        {
          text: this.$t(
            "dcc.administrativeData.coreData.mandatoryLangCodeISO639_1.title"
          ),
          value: "Mandatory Language",
          addElement: () => this.addElement("mandatoryLangCodeISO639_1"),
        },
        {
          text: this.$t(
            "dcc.administrativeData.coreData.usedLangCodeISO639_1.title"
          ),
          value: "Used Language",
          addElement: () => this.addElement("usedLangCodeISO639_1"),
        },
        {
          text: this.$t("dcc.common.identificationListType.title"),
          value: "identifications",
          addElement: () => this.addElement("identifications"),
        },
        {
          text: this.$t(
            "dcc.administrativeData.coreData.reportAmendedSubstituted.title"
          ),
          value: "reportAmendedSubstituted",
          addElement: () => this.addElement("reportAmendedSubstituted"),
        },
      ].filter((x) => !this.blacklist.includes(x.value));
    },
    blacklist() {
      return [
        ...insertIf(this.value.identifications, "identifications"),
        ...insertIf(
          this.value.reportAmendedSubstituted,
          "reportAmendedSubstituted"
        ),
      ];
    },
  },
  watch: {
    isPerformanceRange(val) {
      if (!val) {
        this.performanceDate = this.value.beginPerformanceDate;
      }
    },
    "value.beginPerformanceDate._text"() {
      this.updateIsPerformanceRange();
    },
    "value.endPerformanceDate._text"() {
      this.updateIsPerformanceRange();
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "identifications":
          this.$set(
            this.value,
            "identifications",
            new IdentificationListType()
          );
          this.$nextTick(() => {
            this.$vuetify.goTo(this.$refs[element]);
          });
          break;
        case "reportAmendedSubstituted":
          this.$set(
            this.value,
            "reportAmendedSubstituted",
            new ReportAmendedSubstitutedType()
          );
          this.$nextTick(() => {
            this.$vuetify.goTo(this.$refs[element]);
          });
          break;
        case "mandatoryLangCodeISO639_1":
          this.languageDialog = true;
          this.languageAddingMode = "mandatoryLangCodeISO639_1";
          break;
        case "usedLangCodeISO639_1":
          this.languageDialog = true;
          this.languageAddingMode = "usedLangCodeISO639_1";
          break;
      }
    },
    deleteIdentifications() {
      confirm(this.$t("dcc.common.identificationListType.confirmRemove")) &&
        this.$delete(this.value, "identifications");
    },
    deleteReportAmendedSubstituted() {
      confirm(
        this.$t(
          "dcc.administrativeData.coreData.reportAmendedSubstituted.confirmRemove"
        )
      ) && this.$delete(this.value, "reportAmendedSubstituted");
    },
    updateIsPerformanceRange() {
      this.isPerformanceRange =
        this.value.beginPerformanceDate._text !==
        this.value.endPerformanceDate._text;
    },
  },
};
</script>
